VCS: https://gitlab.cern.ch/ai-config-team/puppet-agent-extra-gems/-/tree/5aab71cb551f4af36078593164b23335f2df41d2
%global ruby_dir 2.5.0

Summary:    Gems to install in puppet-agent space
Name:       puppet-agent-extra-gems
Version:    6.3.0
Release:    3%{?dist}
License:    ASL 2.0
URL:        https://gitlab.cern.ch/ai-config-team/puppet-agent-extra-gems

# We just require puppet-agent and don't want to provide anything either
AutoReqProv: no
AutoReq: no

%global akami_version 1.3.1
%global bcrypt_pbkdf_version 1.0.1
%global builder_version 3.2.3
%global diffy_version 3.2.1
%global ed25519_version 1.2.4
%global gyoku_version 1.3.1
%global hashdiff_version 0.3.7
%global httparty_version 0.18.1
%global httpi_version 2.4.4
%global ipaddress_version 0.8.3
%global landb_version 0.1.2
%global macaddr_version 1.7.2
%global mime_types_version 3.2.2
%global mime_types_data_version 3.2018.0812
%global mini_portile2_version 2.1.0
%global multi_xml_version 0.6.0
%global nokogiri_version 1.7.2
%global nori_version 2.6.0
%global octocatalog_diff_version 2.0.0
%global parallel_version 1.20.1
%global pkg_config_version 1.1.7
%global savon_version 2.11.1
%global sshkeyauth_version 0.0.11
%global systemu_version 2.6.5
%global uuid_version 2.3.8
%global wasabi_version 3.5.0
%global net_ssh_version 6.0.2
%global stomp_version 1.4.9


# Needed for landb
Source0: https://rubygems.org/downloads/akami-%{akami_version}.gem
Source1: https://rubygems.org/downloads/builder-%{builder_version}.gem
Source2: https://rubygems.org/downloads/gyoku-%{gyoku_version}.gem
Source3: https://rubygems.org/downloads/httpi-%{httpi_version}.gem
Source4: https://rubygems.org/downloads/macaddr-%{macaddr_version}.gem
Source5: https://rubygems.org/downloads/mini_portile2-%{mini_portile2_version}.gem
Source6: https://rubygems.org/downloads/nokogiri-%{nokogiri_version}.gem
Source7: https://rubygems.org/downloads/nori-%{nori_version}.gem
Source8: https://rubygems.org/downloads/pkg-config-%{pkg_config_version}.gem
Source10: https://rubygems.org/downloads/savon-%{savon_version}.gem
Source12: https://rubygems.org/downloads/systemu-%{systemu_version}.gem
Source13: https://rubygems.org/downloads/uuid-%{uuid_version}.gem
Source14: https://rubygems.org/downloads/wasabi-%{wasabi_version}.gem
# Built from our own landb repo.
Source15: landb-%{landb_version}.gem

# Octocat stuff
Source20: https://rubygems.org/downloads/diffy-%{diffy_version}.gem
Source21: https://rubygems.org/downloads/hashdiff-%{hashdiff_version}.gem
Source22: https://rubygems.org/downloads/httparty-%{httparty_version}.gem
Source23: https://rubygems.org/downloads/mime-types-data-%{mime_types_data_version}.gem
Source24: https://rubygems.org/downloads/mime-types-%{mime_types_version}.gem
Source25: https://rubygems.org/downloads/multi_xml-%{multi_xml_version}.gem
Source27: https://rubygems.org/downloads/octocatalog-diff-%{octocatalog_diff_version}.gem
Source28: https://rubygems.org/downloads/parallel-%{parallel_version}.gem

# Mcollective stuff
Source30: https://rubygems.org/downloads/sshkeyauth-%{sshkeyauth_version}.gem
Source31: https://rubygems.org/downloads/ed25519-%{ed25519_version}.gem
Source34: https://rubygems.org/downloads/bcrypt_pbkdf-%{bcrypt_pbkdf_version}.gem
Source36: https://rubygems.org/downloads/net-ssh-%{net_ssh_version}.gem
Source37: https://rubygems.org/downloads/stomp-%{stomp_version}.gem

# rubygem-ipaddress for network module.
Source40: https://rubygems.org/downloads/ipaddress-%{ipaddress_version}.gem

BuildRequires: gcc
BuildRequires: libffi-devel
BuildRequires: cmake
BuildRequires: make
BuildRequires: libgit2-devel
BuildRequires: puppet-agent >= 6.0.0
%if 9%{?el6}%{?el7}
BuildRequires: pkgconfig
%else
BuildRequires: pkgconf-pkg-config
%endif

%description
Extra gems that are install puppet-agent space

%prep
cp -p %{SOURCE0} .
cp -p %{SOURCE1} .
cp -p %{SOURCE2} .
cp -p %{SOURCE3} .
cp -p %{SOURCE4} .
cp -p %{SOURCE5} .
cp -p %{SOURCE6} .
cp -p %{SOURCE7} .
cp -p %{SOURCE8} .
cp -p %{SOURCE10} .
cp -p %{SOURCE12} .
cp -p %{SOURCE13} .
cp -p %{SOURCE14} .
cp -p %{SOURCE15} .

cp -p %{SOURCE20} .
cp -p %{SOURCE21} .
cp -p %{SOURCE22} .
cp -p %{SOURCE23} .
cp -p %{SOURCE24} .
cp -p %{SOURCE25} .
cp -p %{SOURCE27} .
cp -p %{SOURCE28} .

cp -p %{SOURCE30} .
cp -p %{SOURCE31} .
cp -p %{SOURCE34} .
cp -p %{SOURCE36} .
cp -p %{SOURCE37} .

cp -p %{SOURCE40} .

%build

# Note the use of `--ignore-dependencies` below. We find out about missing
# dependencies till runtime basically.

# Need an extra flag for nokogiri so do it first.
NOKOGIRI_USE_SYSTEM_LIBRARIES=1 CFLAGS="%{optflags}" /opt/puppetlabs/puppet/bin/gem install \
        -V \
        --no-rdoc \
        --no-ri \
        --local \
        --force \
        --build-root . \
        --ignore-dependencies \
        nokogiri-*gem \
        -- \
        --use-system-libraries \
        --with-xml2-lib=/opt/puppetlabs/puppet/lib \
        --with-xml2-include=/opt/puppetlabs/puppet/include/libxml2 \
        --with-xslt-lib=/opt/puppetlabs/puppet/lib \
        --with-xslt-include=/opt/puppetlabs/puppet/include/libxslt \
        --with-exslt-lib=/opt/puppetlabs/puppet/lib \
        --with-exslt-include=/opt/puppetlabs/puppet/include/libexslt


# Simple gems
echo 'Installing rest of gems in BUILDROOT'
for GEM in mini_portile2-*gem pkg-config*gem ipaddress-*.gem sshkeyauth-*.gem ed25519-*.gem \
           net-ssh-*gem stomp-*.gem bcrypt_pbkdf-*.gem \
           diffy-*.gem hashdiff-*.gem httparty-*.gem mime-types-data-*.gem mime-types-3*.gem \
           multi_xml-*.gem octocatalog-diff-*.gem parallel-*gem  \
           akami-*.gem gyoku-*.gem macaddr-*.gem savon-*.gem systemu-*.gem wasabi-*.gem \
           builder-*.gem httpi-*.gem  nori-*.gem  uuid-*.gem \
           landb-%{landb_version}.gem
do

CFLAGS="%{optflags}" /opt/puppetlabs/puppet/bin/gem install \
        -V \
        --no-rdoc \
        --no-ri \
        --local \
        --build-root . \
        --force \
        --ignore-dependencies \
        --document=ri,rdoc \
        $GEM
done


# Remove some irrelevent files that break package build:
rm -rf ./opt/puppetlabs/puppet/lib/ruby/gems/*/gems/*/spec
rm -rf ./opt/puppetlabs/puppet/lib/ruby/gems/*/gems/*/test
rm -rf ./opt/puppetlabs/puppet/lib/ruby/gems/*/gems/*/doc
rm -rf ./opt/puppetlabs/puppet/lib/ruby/gems/*/gems/*/vendor
rm -rf ./opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/cache
rm -rf ./opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/doc
rm -rf ./opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/build_info/nokogiri-1.7.2.info

find opt -name .gitignore -exec rm {} \;
find opt -name .rspec -exec rm {} \;
find opt -name .travis.yml -exec rm {} \;
find opt -name .rubocop.yml -exec rm {} \;

# We do not need rugged and it is a pain so get rid of need for it.
sed -i '/rugged/d' ./opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/specifications/octocatalog-diff-%{octocatalog_diff_version}.gemspec
sed -i '/rugged/d' ./opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/octocatalog-diff-%{octocatalog_diff_version}/lib/octocatalog-diff/catalog-util/git.rb


%install
mkdir -p %{buildroot}/opt
cp -a ./opt/puppetlabs \
        %{buildroot}/opt

%files
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/landb-%{landb_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/akami-%{akami_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/bcrypt_pbkdf-%{bcrypt_pbkdf_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/builder-%{builder_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/diffy-%{diffy_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/ed25519-%{ed25519_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/gyoku-%{gyoku_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/hashdiff-%{hashdiff_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/httparty-%{httparty_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/httpi-%{httpi_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/ipaddress-%{ipaddress_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/macaddr-%{macaddr_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/mime-types-%{mime_types_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/mime-types-data-%{mime_types_data_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/mini_portile2-%{mini_portile2_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/multi_xml-%{multi_xml_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/nokogiri-%{nokogiri_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/nori-%{nori_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/octocatalog-diff-%{octocatalog_diff_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/parallel-%{parallel_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/pkg-config-%{pkg_config_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/savon-%{savon_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/sshkeyauth-%{sshkeyauth_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/systemu-%{systemu_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/uuid-%{uuid_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/wasabi-%{wasabi_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/net-ssh-%{net_ssh_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/gems/stomp-%{stomp_version}

/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/extensions/%{_arch}-linux/%{ruby_dir}/bcrypt_pbkdf-%{bcrypt_pbkdf_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/extensions/%{_arch}-linux/%{ruby_dir}/nokogiri-%{nokogiri_version}
/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/extensions/%{_arch}-linux/%{ruby_dir}/ed25519-%{ed25519_version}

/opt/puppetlabs/puppet/lib/ruby/gems/%{ruby_dir}/specifications

/opt/puppetlabs/puppet/bin/httparty
/opt/puppetlabs/puppet/bin/nokogiri
/opt/puppetlabs/puppet/bin/octocatalog-diff
/opt/puppetlabs/puppet/bin/uuid
/opt/puppetlabs/puppet/bin/catstomp
/opt/puppetlabs/puppet/bin/stompcat

%changelog
* Sat Feb 20 2021 Steve Traylen <steve.traylen@cern.ch> 6.3.0-3
- Rebuild to add stream8 package

* Thu Feb 4 2021 Steve Traylen <steve.traylen@cern.ch> 6.3.0-2
- Remove ExclusiveArch as aarch64 now available.

* Thu Jan 14 2021 Steve Traylen <steve.traylen@cern.ch> 6.3.0-1
- Update octocatalog-diff to version 2

* Thu Jan 7 2021 Steve Traylen <steve.traylen@cern.ch> 6.2.0-1
- Update httparty gem

* Thu Aug 13 2020 Steve Traylen <steve.traylen@cern.ch> 6.1.0-1
- Add stomp

* Wed Aug 12 2020 Steve Traylen <steve.traylen@cern.ch> 6.0.1-1
- Drop ffi since in puppet-agent6

* Wed Aug 12 2020 Steve Traylen <steve.traylen@cern.ch> 6.0.0-1
- Puppet6 build with newer ruby

* Thu Jul 23 2020 Steve Traylen <steve.traylen@cern.ch> 1.4.0-2
- Relax puppet-agent requirement

* Tue May 26 2020 Steve Traylen <steve.traylen@cern.ch> 1.4.0-1
- Remove necessity for rugged. We do not do octocat operations
  against git.

* Tue May 5 2020 Steve Traylen <steve.traylen@cern.ch> 1.3.0-1
- Build nokogiri against puppetlabs libxml2.

* Tue May 5 2020 Steve Traylen <steve.traylen@cern.ch> 1.2.1-1
- Newer net-ssh, drop all the rbnacl stuff

* Tue May 5 2020 Steve Traylen <steve.traylen@cern.ch> 1.1.0-1
- Install ffi, needed after all for mco.

* Wed Apr 29 2020 Steve Traylen <steve.traylen@cern.ch> 1.0.0-1
- Initial Package


